/* Problem URL: https://codeforces.com/problemset/problem/2034/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    V<string> a(n);
    cin >> a;

    V<V<bool>> loop(n, V<bool>(m));

    map<char, array<int, 2>> var;
    var['U'] = {-1, 0};
    var['D'] = {1, 0};
    var['L'] = {0, -1};
    var['R'] = {0, 1};

    V<V<bool>> vis(n, V<bool>(m));
    V<V<bool>> frame(n, V<bool>(m));

    function<int(int, int)> dfs = [&](int i, int j) {
        if (i < 0 || i >= n || j < 0 || j >= m) {
            return false;
        }

        if (frame[i][j] || loop[i][j]) {
            loop[i][j] = true;
            return true;
        }

        if (vis[i][j]) {
            return false;
        }

        vis[i][j] = true;
        frame[i][j] = true;

        if (a[i][j] == '?') {
            repv(k, var) {
                int id = i + k.second[0];
                int jd = j + k.second[1];

                if (dfs(id, jd)) {
                    a[i][j] = k.first;
                    loop[i][j] = true;
                    frame[i][j] = false;
                    return true;
                }
            }

            frame[i][j] = false;
            return false;
        }

        auto [c, k] = var[a[i][j]];
        int id = i + c;
        int jd = j + k;

        if (dfs(id, jd)) {
            loop[i][j] = true;
            frame[i][j] = false;
            return true;
        }

        frame[i][j] = false;
        return false;
    };

    rep(i, n) {
        rep(j, m) {
            dfs(i, j);
        }
    }

    int ans = 0;
    rep(i, n) {
        rep(j, m) {
            ans += loop[i][j];
        }
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
